#include <iostream>
using namespace std;
int main()
{
    int n, k;
    cin>>n>>k;
    int a[n], d[n];
    unsigned long long rez=0;
    cin>>a[0];
    d[0]=a[0];
    for(int i=1; i<n; i++){
        cin>>a[i];
        d[i]=d[i-1]+a[i];
    }
    if(k==0){
        rez=d[n-1];
    }
    else{
        for(int i=0; i<n; i++){
            rez+=d[i];
            rez%=(int)(1e9+7);
        }
        for(int i=1; i<n; i++){
            for(int j=i; j<n; j++){
                if(i==j){
                    rez+=a[i];
                    rez%=(int)(1e9+7);
                }
                else{
                    rez+=d[j]-d[i-1];
                    rez%=(int)(1e9+7);
                }
            }
        }
    }
    cout<<rez<<"\n";
    return 0;
}